config/routes.rb
HeaderAd::Application.routes.draw do

  #get "corheaders/hbase"
  match 'corheaders/hbase/:headerid', to: 'corheaders#hbase', via: [:get]
  match 'corheaders/count/:headerid', to: 'corheaders#count', via: [:get]
  match 'corheaders/links/:headerid', to: 'corheaders#links', via: [:get]
  # Newsletter
  match 'corheaders/newsletter', to: 'corheaders#newsletter', via: [:get]
  # Analytics 
  match 'header/:id/analytics', to: 'headers#analytics',:as => 'analytics',via: [:get]
  match 'corheaders/renderjs/:headerid', to: 'corheaders#renderjs', via: [:get]

  devise_for :users, :controllers => { :omniauth_callbacks => "users/omniauth_callbacks" }

  authenticated :user do
    root to: "headers#index", :as => "dashbord"
  end

  get "pages/index"
  
  get "/admin" => "admin/base#index", :as => "admin"

  namespace "admin" do

    resources :users

  end
  resources :headers do
  	get :preview, :on => :member
  end

  root to: "pages#index"

end

app/models/header.rb
class Header < ActiveRecord::Base
	belongs_to :user
	has_many :links
	has_many :trackers
	has_many :newsletters
	validates :name,:site, :presence => true
	validates :site, :format => URI::regexp(%w(http https))
	# validates :height,:split_header,:numeric => true
	mount_uploader :logo, LogoUploader

	def style_for_header
		style = "background-color:##{background};" if background
		style += "height: #{height}px;" if height
		if show_border
			style += "border-bottom:#{border_bottom}px solid;" if border_bottom
			style += "border-color: ##{border_color};" if border_color
			style += "box-shadow: ##{box_shadow}px;" if box_shadow
			style += "clear:both;"
		end
		style

	end
end

app/controllers/headers_controller.rb
class HeadersController < ApplicationController
  before_action :authenticate_user!
  before_action :find_header, :only => [:edit,:update,:preview,:show]

  def new
    @header = current_user.headers.new
  end

  def create
    @header = current_user.headers.new(header_params)
    if @header.save
      flash[:notice] = 'Header Ad successfully created'
      redirect_to header_path(@header.id)
    else
      render :action => :new
    end
  end

  def edit
  end

  def update
    if @header.update_attributes(header_params)
      flash[:notice] = 'Header Ad has been successfully updated'
      redirect_to header_path(@header)
    else
      render :action => :edit
    end
  end

  def show
  end

  def index
    @headers = current_user.headers
    @headers << Header.find_by_public(true) unless Header.find_by_public(true).nil?
    @host_name = request.env["HTTP_HOST"]
    @twitter_message = "Message "
  end

  def preview
  end

  def analytics
    @header = Header.find(params[:id])
    @tracker = @header.trackers.all
  end


  protected
  def find_header
    @header = Header.find params[:id]
  end

  private
  def header_params
    params.require(:header).permit(:name, :site, :height, :background, :logo, :split_header, :add_back_button,:border_bottom ,:show_border ,:border_color ,:box_shadow,:fb_page,:twitter_page,:header_text,:newsletter_email)
  end
end

app/helpers/headers_helper.rb
module HeadersHelper
	def headers_chart_data
		@header.links.uniq.map do |link|
			{
				link_id: link.id,
				count: @header.trackers.where("link_id=?",link.id).count
			}
		end
	end	
end

app/views/headers/_form.html.erb
<%= form_for @header,:html=>{:class=> 'header_form'} do |f| %>
  <%= f.error_messages %>
  <div class="form-group">
    <%= f.label :name, :class => "col-sm-1 control-label" %>
    <div class="col-sm-4">
      <%= f.text_field :name, :class => "form-control", :placeholder => 'Enter name here' %>
    </div>
  </div>

  <div class="form-group">
    <%= f.label :site, :class => "col-sm-1 control-label" %>
    <div class="col-sm-4">
      <%= f.text_field :site, :class => "form-control", :placeholder => 'Enter site url here' %>
    </div>
  </div>
  
  <div class="form-group">
    <div class="col-sm-offset-1 col-sm-4">
     <%= f.submit  %>
    </div>
  </div>

<% end %>

app/views/headers/_header.html.erb
<div class='header-ad' style="<%= @header.style_for_header unless @header.style_for_header.nil? %>">
     <div class="logo" style="float:left; width:20%; margin-left:5%;" >
      <%= image_tag (@header.logo ? @header.logo_url : 'default_logo.png' ), :id => 'header-ad-img' %>
     </div><!--header_logo-->
     <div class="" style="float:right; width:70%;  margin-right:5%;">
        <%if @header.add_back_button  %>
         <div class="" style="float:right; margin-top:10px;">
          <button id='header-back-btn' class="ios-6-arrow left light" data-title="Light arrow" style="margin-left:15px;background: white;color: saddlebrown;border: 1px solid #e3e3e3;padding: 5px 12px;border-bottom-right-radius: 8px;border-top-left-radius: 11px;cursor: pointer;">Back</button>
         </div>    
        <%else %>
          <div class="" style="float:right; margin-top:10px;">
          <button id='header-back-btn' class="ios-6-arrow left light" data-title="Light arrow" style="margin-left:15px;background: white;color: saddlebrown;border: 1px solid #e3e3e3;padding: 5px 12px;border-bottom-right-radius: 8px;border-top-left-radius: 11px;cursor: pointer;display: none;">Back</button>
         </div>    
        <%end %>
       <div class="" style="float:right; margin-top:10px;">
        <%= text_field_tag 'email', nil, placeholder: 'Enter email address'  %>
        <%= button_tag "submit" %>
       </div>
        <%if !(@header.twitter_page.nil?) && (@header.twitter_page != "") %>
       <div id="header-ad-soc-head" style="float:right; margin-top:10px">
        <a href='http://twitter.com/share?url=<%= CGI::escape(root_url) %>&text=<%= CGI::escape(@header.twitter_page) %>' style='margin-right:15px' class='twit' target='_blank'>
        <img src='http://www.apkreleases.com/wp-content/themes/apkr-1.3/images/twitter.png' >
        </a>
        <a href='https://www.facebook.com/sharer/sharer.php?u=<%= CGI::escape(@header.fb_page) %>' style='margin-right:25px' class='fb' target='_blank'>
        <img src='http://india.gov.in/sites/default/themes/indiaportal/images/facebook32x32.png' ></a>
       </div>
        <%else %>
       <div id="header-ad-soc-head" style="float:right; margin-top:10px;display:none">
        <a href='http://twitter.com/share?url=' style='margin-right:15px' class='twit' target='_blank'>
        <img src='http://www.apkreleases.com/wp-content/themes/apkr-1.3/images/twitter.png' >
        </a>
        <a href='https://www.facebook.com/sharer/sharer.php?u=' style='margin-right:25px' class='fb' target='_blank'>
        <img src='http://india.gov.in/sites/default/themes/indiaportal/images/facebook32x32.png' ></a>
       </div>
         <%end %>
     <!-- <div class="back-button_container split-col col-md-3">
      <div class="fb-like" data-href="https://developers.facebook.com/docs/plugins/" data-layout="button" data-action="like" data-show-faces="false" data-share="false"></div>
      
      <a href="<%= @header.twitter_page %>" class="twitter-share-button" data-lang="en">Tweet</a>
      <%= link_to image_tag('back_button.png',:id => 'back_button'),'' if @header.add_back_button!=false %>
     </div> -->
     <div class="clear_fix" style="width:100%; clear:both;"></div>
     
     </div><!--heddr_right-->
     <div class="clear_fix" style="width:100%; clear:both;"></div>

</div><!--header-ad-->

app/views/headers/analytics.html.erb
<%if @header.links.empty? %>
<div class="alert alert-success">
<button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">×</span><span class="sr-only">Close</span></button>No analytics until now 
</div>
<%=link_to "Back",root_url, :class => 'btn btn-info' %>
<%else %>
<%= content_tag :div, "", id: @header.name, data: {headers: headers_chart_data} %>

<script>
new Morris.Line({
  // ID of the element in which to draw the chart.
  element: '<%=@header.name %>',
  // Chart data records -- each entry in this array corresponds to a point on
  // the chart.
  data: $("#<%=@header.name %>").data("headers"),
  // The name of the data record attribute that contains x-values.
  xkey: 'link_id',
  // A list of names of data record attributes that contain y-values.
  ykeys: ['count'],
  // Labels for the ykeys -- will be displayed when you hover over the
  // chart.
  labels: ['Value']
});
</script>

<table class="table table-hover" style="width:60%">
<hr>
<legend>Header Links</legend>
  <thead>
    <tr>
      <th>#</th>
      <th>Link</th>
      <th>Count</th>
    </tr>
  </thead>
  <tbody>
   <% @header.links.uniq.each do |l| %>
    <tr>
      <td></td>
      <td><%= l.links %></td>
      <td><%= @header.trackers.where("link_id=?",l.id).count %></td>
    </tr>
   <%end %>
  </tbody>
</table>
<%end %>

app/views/headers/edit.html.erb
<%= render :partial => 'form' %>

app/views/headers/index.html.erb
<div class="container">
	<div class="row">
		<h3 class="col-md-4 col-sm-6">My Headers</h3>
		<%= link_to 'Add New Header Ad',new_header_path, :class => 'pull-right btn btn-primary btn-small'	 %>
	</div>

	<div class="row">
		
	</div>

	<% unless @headers.blank? %>

		<div class="row">
			<% @headers.each do |h| %>
		  	<div class="col-sm-6 col-sm-6d-4">
		    <div class="thumbnail">
		      <div class="caption">
		        <h3><%= link_to h.name, header_path(h) %></h3>
		        <p><%= link_to h.site,h.site	 %></p>
		        <p class="group_ls"><%= link_to 'Edit', header_path(h)%><a href="#" class="e-target">Embed</a><%= link_to 'Analytics', analytics_path(h)%></p>
		      </div>
		      <div class="embed" style="height:130px;overflow:scroll;padding:5px 10px">
					&lt;script type='text/javascript' &gt;
					    $(document).ready(function(){
							var data = $.ajax({
							  url: "http://<%= @host_name %>/corheaders/renderjs/<%= h.id %>.js",
							  type: "GET",
							  crossDomain: true,
							  xhrFields: {
							    withCredentials: true
							  }
							});
					    });
					    
						setTimeout(function(){sendlinks()}, 3000);
					&lt;/script&gt;
		      </div>

		    </div>
		  	</div>
		  <% end %>
		</div>
		
	<% end %>

</div>

<script>
/* Script Tag to Fetch Embed and trigger them*/
 $(".embed").hide();
 $(".e-target").click(function(){
 	$(this.parentNode.parentNode.parentNode).find(".embed").show();
 });


</script>

app/views/headers/new.html.erb
<h2>Add new header ads </h2>
<%= render :partial => 'form' %>

app/views/headers/show.html.erb
<div id="editor-wrapper">
<%= form_for @header do |f| %>
  <div id="top-menu">
    <div id="toolbar">
      <div class="row">
        <div class="header-name col-md-4">Header Name: <%= @header.name %></div>
        <div class="split-col col-md-4">
          Split header to col: 
          <%= f.select :split_header,options_for_select((1..5).map{|r|[r,r]},@header.split_header) , :class => 'form-inline' %>
        </div>
        <div class="col-md-4"><%=  f.submit 'Save',:class => 'btn  btn-warning save-btn pull-right' %></div>
      </div>
    </div> 
    
  </div>

  <div id="side-bar" class="sidebar-width">
    <div id="side-bar-tool">
      <div class="panel-group" id="accordion">
        <div class="panel panel-default">
          <div class="panel-heading">
            <h4 class="panel-title">
              <a data-toggle="collapse" data-parent="#accordion" href="#collapseOne">
                Basic Style
              </a>
            </h4>
          </div>
          <div id="collapseOne" class="panel-collapse collapse in">
            <div class="panel-body">
              <form class="form-horizontal" role="form">
                <div class="form-group">
                  <%= f.label :height,'Header-Height' , :class=>"col-sm-12 control-label"  %>
                  <div class="col-sm-12">
                    <%= f.text_field :height,:class=>"form-control",:id=>"ex1Slider", :data => {:slider_min=>"50", :slider_max=>"100",:slider_step=>"1" ,:slider_value=>"#{ @header.height }"} %>
                  </div>
                </div>

                <div class="form-group">
                  <%= f.label :background,'Header Background' , :class=>"col-sm-6 control-label"  %>
                  <div class="col-sm-6">
                    <%= f.text_field :background, :id=>"color-picker", :class=>'colpicker headbackground' %>
                  </div>
                </div>

                <div class="form-group">
                  <%= f.label :show_border,'Border' , :class=>"col-sm-8 control-label"  %>
                  <div class="col-sm-4">
                    <%= f.check_box :show_border, :label=>false %>
                  </div>
                </div>
                 <div class="form-group">
                 <%= f.label :border_color,'- Border-Color' , :class=>"col-sm-8 control-label"  %>
                 <div class="col-sm-4">
                  <%= f.text_field :border_color, :id=>"color-picker", :class=>'colpicker bordercolor' %>
                </div>
                </div>
                 <div class="form-group">
                 <%= f.label :border_bottom,'- Border-Bottom' , :class=>"col-sm-8 control-label"  %>
                 <div class="col-sm-4" id="border_bottom">
                  <%= f.text_field :border_bottom, :class=>"form-control",:id=>"bottom-slider", :data => {:slider_min=>"0", :slider_max=>"10",:slider_step=>"1" ,:slider_value=>"#{@header.border_bottom}"} %>
                 </div>
                </div>
                 <div class="form-group">
                  <%= f.label :box_shadow,'-Box-Shadow' , :class=>"col-sm-8 control-label"  %>
                  <div class="col-sm-4">
                    <%= f.text_field :box_shadow, :class=>"form-control",:id=>"shadow-slider", :data => {:slider_min=>"0", :slider_max=>"10",:slider_step=>"1" ,:slider_value=>"#{@header.box_shadow}"} %>
                  </div>
                </div>
                <div class="form-group">
                  <%= f.label :logo,'Logo' , :class=>"col-sm-8 control-label"  %>
                  <div class="col-sm-4">
                    <%= f.file_field :logo %>
                  </div>
                </div>
                 <div class="form-group">
                   <%= f.label :add_back_button,'Add Back Button' , :class=>"col-sm-8 control-label"  %>
                   <div class="col-sm-4">
                    <%= f.check_box :add_back_button %>
                  </div>
                </div>
               
              </form>
            </div>
          </div>
        </div>
        <div class="panel panel-default">
          <div class="panel-heading">
            <h4 class="panel-title">
              <a data-toggle="collapse" data-parent="#accordion" href="#collapseTwo">
                Add-on
              </a>
            </h4>
          </div>
          <div id="collapseTwo" class="panel-collapse collapse">
            <div class="panel-body">
              <div class="social-media">  
                Social media
                <hr>
                <div class="form-group">
                  <%= f.label :soc_ex,'Social Network Icons' , :class=>"col-sm-8 control-label"  %>
                  <div class="col-sm-4">
                  <%if !(@header.twitter_page.nil?) && (@header.twitter_page != "") %>
                    <input type="checkbox" id="header-ad-soc" value="Bike" checked>
                  <%else %>
                    <input type="checkbox" id="header-ad-soc" value="Bike">
                  <% end %>
                  </div>
                </div>
                <%if !(@header.twitter_page.nil?) && (@header.twitter_page != "") %>
                  <div id="header-ad-soc-trigger">
                <%else %>
                 <div id="header-ad-soc-trigger" style="display:none">
                <%end %>
                  <div class="form-group">
                  <%= f.label :fb_page,'facebook' , :class=>"col-sm-4 control-label"  %>
                  <div class="col-sm-4">
                    <%= f.text_field :fb_page, :placeholder => "Url of that awesome thing you want to share" %>
                  </div>
                </div>
                <div class="form-group">
                  <%= f.label :twitter_page,'twitter' , :class=>"col-sm-4 control-label"  %>
                  <div class="col-sm-4">
                    <%= f.text_field :twitter_page, :placeholder => "Your Awesome Tweet" %>
                  </div>
                </div>
                </div>
              </div>
              <div class="social-media">  
                <div class="form-group">
                  <%= f.label :header_text,'Heading' , :class=>"col-sm-4 control-label"  %>
                  <div class="col-sm-4">
                    <%= f.text_field :header_text %>
                  </div>
                </div>
              </div>
              <div class="social-media">  
                <div class="form-group">
                  <%= f.label :newsletter_email,'Newsletter' , :class=>"col-sm-4 control-label"  %>
                  <div class="col-sm-4">
                    <%= f.text_field :newsletter_email %>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
<% end %>

  <div id="preview">
    <%= render :partial=>'header' %>
    <iframe src="<%= @header.site %>" width="100%" height="75%" frameborder='0'></iframe>
  </div>
  <div id="bottom-menu">
    <div class="form-group">
      <label for="inputEmail3" class="col-sm-2 control-label">Enter site for preview</label>
      <div class="col-sm-4">
        <input type="text_field" class="form-control" id="header_site" placeholder="site" value="<%= @header.site %>">
       
      </div>
       <button class="preview">Preview</button>
    </div>
  </div>

</div>

<% content_tag :javascript do %>
  jQuery(document).ready(function(){
    jQuery('#header_height').slider();
  })
<% end -%>
<script>

(function ($) {
    $("#header_add_back_button").change(function(){
      $("#header-back-btn").toggle("show");
    });
    $("#header-ad-soc").change(function(){
      $("#header-ad-soc-trigger").toggle("show");
      $("#header-ad-soc-head").toggle("show");
    });
    $("#ex1Slider").slider({
      tooltip: 'always'
    }).on('slide',function(e){
      $('.header-ad').css({'height':e.value})
    });
    $("#shadow-slider").slider({
      tooltip: 'always'
    });
    $("#bottom-slider").slider({
      tooltip: 'always'
    }).on('slide',function(e){
      $('.header-ad').css({'border-bottom':e.value+"px solid"})
    });
    $('.colpicker').each(function(){
      var style = "#"+$(this).attr('value');
      $(this).css('border-color',style);
    })
   
    $('.colpicker').colpick({
      layout:'hex',
      submit:0,
      colorScheme:'dark',
      onChange:function(hsb,hex,rgb,el,bySetColor) {
        $(el).css('border-color','#'+hex);
        // Fill the text box just if the color was set using the picker, and not the colpickSetColor function.
        if(!bySetColor) $(el).val(hex);
        if($(el).hasClass('headbackground')){
          $('.header-ad').css({'background-color': '#'+hex});
        }
        if($(el).hasClass('bordercolor')){
          $('.header-ad').css({'border-color': '#'+hex});
        }
      }
    }).keyup(function(){
      $(this).colpickSetColor(this.value);
    })
    $('.colpick').css('z-index',9999);
    $('#header_add_back_button').click(function () {
        $("#back_button").toggle(this.checked);
    });
    
  })(jQuery);
  $(document).on('click','.preview',function(){
    var url = String($('#header_site').val())
    $('iframe').attr('src', url);
  });
  
  showImagePreview('#header_logo','.logo img');
  function assign(){
    var width = $("#border_bottom .slider-selection")[0].style.width;
    $("#border_bottom input")[0].value = width;
  }
</script>
<!-- facebook like code -->
<div id="fb-root"></div>
<script>
  (function(d, s, id) {
    var js, fjs = d.getElementsByTagName(s)[0];
    if (d.getElementById(id)) return;
    js = d.createElement(s); js.id = id;
    js.src = "//connect.facebook.net/en_US/sdk.js#xfbml=1&appId=433146980055767&version=v2.0";
    fjs.parentNode.insertBefore(js, fjs);
  }(document, 'script', 'facebook-jssdk'));

  // twitter script
  !function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0];if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src="https://platform.twitter.com/widgets.js";fjs.parentNode.insertBefore(js,fjs);}}(document,"script","twitter-wjs");

</script>
<style>
  .adj_show{
    position:fixed;
    top: 50px;;
    left: 0px;
    right: 0;
    z-index: 9999;
  }
</style>